diff --git a/Documentation/devicetree/bindings/pinctrl/mediatek,mt7620-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/mediatek,mt7620-pinctrl.yaml
index 591bc0664ec6..221adcef6e14 100644
--- a/Documentation/devicetree/bindings/pinctrl/mediatek,mt7620-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/mediatek,mt7620-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,mt7620-pinctrl
+    oneOf:
+      - const: ralink,mt7620-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':
diff --git a/Documentation/devicetree/bindings/pinctrl/mediatek,mt7621-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/mediatek,mt7621-pinctrl.yaml
index e568b9c13727..5e29332c794b 100644
--- a/Documentation/devicetree/bindings/pinctrl/mediatek,mt7621-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/mediatek,mt7621-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,mt7621-pinctrl
+    oneOf:
+      - const: ralink,mt7621-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':
diff --git a/Documentation/devicetree/bindings/pinctrl/mediatek,mt76x8-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/mediatek,mt76x8-pinctrl.yaml
index 31849dd5940b..fef7728a5220 100644
--- a/Documentation/devicetree/bindings/pinctrl/mediatek,mt76x8-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/mediatek,mt76x8-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,mt76x8-pinctrl
+    oneOf:
+      - const: ralink,mt76x8-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':
diff --git a/Documentation/devicetree/bindings/pinctrl/ralink,rt2880-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/ralink,rt2880-pinctrl.yaml
index 43b33dbf115b..71bc961b856e 100644
--- a/Documentation/devicetree/bindings/pinctrl/ralink,rt2880-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/ralink,rt2880-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,rt2880-pinctrl
+    oneOf:
+      - const: ralink,rt2880-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':
diff --git a/Documentation/devicetree/bindings/pinctrl/ralink,rt305x-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/ralink,rt305x-pinctrl.yaml
index 95a904273009..bde19a00af80 100644
--- a/Documentation/devicetree/bindings/pinctrl/ralink,rt305x-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/ralink,rt305x-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,rt305x-pinctrl
+    oneOf:
+      - const: ralink,rt305x-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':
diff --git a/Documentation/devicetree/bindings/pinctrl/ralink,rt3352-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/ralink,rt3352-pinctrl.yaml
index c9bc6cfd834c..f87038cadfc8 100644
--- a/Documentation/devicetree/bindings/pinctrl/ralink,rt3352-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/ralink,rt3352-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,rt3352-pinctrl
+    oneOf:
+      - const: ralink,rt3352-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':
diff --git a/Documentation/devicetree/bindings/pinctrl/ralink,rt3883-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/ralink,rt3883-pinctrl.yaml
index 8d14e525b25e..3a13a69f7752 100644
--- a/Documentation/devicetree/bindings/pinctrl/ralink,rt3883-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/ralink,rt3883-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,rt3883-pinctrl
+    oneOf:
+      - const: ralink,rt3883-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':
diff --git a/Documentation/devicetree/bindings/pinctrl/ralink,rt5350-pinctrl.yaml b/Documentation/devicetree/bindings/pinctrl/ralink,rt5350-pinctrl.yaml
index f248202ce866..1231f442afbc 100644
--- a/Documentation/devicetree/bindings/pinctrl/ralink,rt5350-pinctrl.yaml
+++ b/Documentation/devicetree/bindings/pinctrl/ralink,rt5350-pinctrl.yaml
@@ -17,7 +17,10 @@ description: |
 
 properties:
   compatible:
-    const: ralink,rt5350-pinctrl
+    oneOf:
+      - const: ralink,rt5350-pinctrl
+      - const: ralink,rt2880-pinmux
+        deprecated: true
 
 patternProperties:
   '-pins$':